#include "board.h"

void CBoard::initialize()
{
	boardWidth=0;
	board=NULL;
	column.setBKGroundColor(DefaultIndexBKGroundColor);
	column.setFontColor(DefaultIndexFontColor);
	row.setBKGroundColor(DefaultIndexBKGroundColor);
	row.setFontColor(DefaultIndexFontColor);
}

void CBoard::setValue(char** matrix)
{
	for (int i=0; i<boardWidth; i++)
	{
		for (int j=0; j<boardWidth; j++)
		{
			board[i][j].setValue(matrix[i][j]);
		}
	}
}

void CBoard::setSize(int size)
{
	boardWidth=size;
	board=new CTokens[size];
	row.setLength(size);
	column.setLength(size);
	row.setDirection(true);
	column.setBKGroundColor(DefaultIndexBKGroundColor);
	column.setFontColor(DefaultIndexFontColor);
	row.setBKGroundColor(DefaultIndexBKGroundColor);
	row.setFontColor(DefaultIndexFontColor);
	for (int i=0; i<size; i++)
	{
		board[i].setLength(size);
		row[i].setNumber(i);
		column[i].setNumber(i);
	}
}

CBoard::CBoard()
{
	initialize();
}

CBoard::CBoard(int size)
{
	initialize();
	setSize(size);
}

void CBoard::setValue(int r, int c, char ch)
{
	board[r][c].setValue(ch);
}

char CBoard::getValue(int r, int c)
{
	return board[r][c].getValue();
}

void CBoard::display(int x, int y)
{
	row.display(x, y+4);
	column.display(x+4, y);
	for (int i=0; i<boardWidth; i++)
	{
		board[i].display(x+4, y+(i+1)*4);
	}
}

		

