#include "control.h"

CDeck playingDeck, playedDeck(true);
CBoard board;



void CControl::playGame()
{
	bool quit=false;
	int choice;
	initPlayGame();
	choice=listenMenu();
	while (true)
	{
		switch (choice)
		{
		case SELECTCARD:
			if (!player[turn].traded)
			{
				choice =doSelectCard();			
			}
			else
			{
				choice=listenMenu();
			}
			break;
		case SELECTLETTER:
			choice=doSelectLetter();
			break;
		case TRADE:
			if (!player[turn].traded)
			{
				choice =doTrade();
			}
			else
			{
				choice=listenMenu();
			}
			break;
		case PICKCARD:
			choice=doPickCard();
			break;
		case FORMWORD:
			choice=doFormWord();
			break;
		case QUIT:
			return;
			break;
		case ENDROUND:
			choice=doEndRound();
			break;
		case CANCEL:
			choice =doCancel();
			break;
		case DISCARD:
			choice =doDiscard();
			break;
		default:
			choice=listenMenu();
			break;
		}
	}
}

int CControl::doDiscard()
{
	CToken temp;
	//show prompt message, this is no cancel operation
	for (int i=0; i<player[turn].rackCard.selectedCount; i++)
	{
		temp=player[turn].rackCard.tokens[player[turn].rackCard.selected[i]];
		playedDeck.addCard(temp);
	}
	player[turn].rackCard.updateRack();
	playedDeck.show();
	player[turn].rackCard.show();
	return listenMenu();
}


int CControl::doCancel()
{
	player[turn].rackCard.updateRack(true);
	player[turn].rackLetter.updateRack(true);
	player[turn].traded=false;
	player[turn].show();
	board.update(true);
	board.show();
	return listenMenu();
}

int CControl::doEndRound()
{
	showMessage(ENDROUND);
	board.update();
	fillUpRack();
	player[turn].rackLetter.updateRack();
	player[turn].rackCard.updateRack();
	//player[turn].show();
	
	//set scoreboard to show current player
	nextTurn();
	
	//update all view to show
	//fillUpRack();
	player[turn].traded=false;
	show();
	return listenMenu();
}

void CControl::nextTurn()
{
	turn=(turn+1)%2;//next player
}


int CControl::doFormWord()
{
	int row, col;
	char dir;
	showMessage(FORMWORD);
	showMessage(INPUTPLACEWORDINFO);
	showMessage(INPUTROW);

	row=listener.listenInt();
	
	showMessage(INPUTCOL);
	col=listener.listenInt();
	showMessage(INPUTDIRECTION);
	dir=listener.listenChar();

	//have no verification here now, but need future
	board.placeWord(row, col, player[turn].rackLetter.exportWord(), dir=='V'||dir=='v');
	board.show();
	return listenMenu();
}


//I want a simple solution: you can only pick card if your last selected card
//has been discarded
int CControl::doPickCard()
{
	CToken target, source;
	int& count=player[turn].rackCard.selectedCount;
	int index=player[turn].rackCard.selected[count-1];

	if (count>0)
	{
		target=player[turn].rackCard.tokens[index];
		if (target.getValue()==0)//empty space
		{
			if (playedDeck.removeCard(source))
			{
				//remove from selected count and update displaying
				player[turn].rackCard.tokens[index]=source;
				count--;
				/*
				if (player[turn].rackCard.tokens[
					player[turn].rackCard.selected[player[turn].rackCard.selectedCount-1]]
				player[turn].rackCard.tokens[
					player[turn].rackCard.selected[--player[turn].rackCard.selectedCount]]=temp;
					*/

				playedDeck.display(DefaultPlayedDeck_x, DefaultPlayedDeck_y);
				player[turn].rackCard.show();
			}
		}
	}
	return listenMenu();	
}

int CControl::doSelectLetter()
{
	int choice;
	showMessage(SELECTLETTER);
	choice=listener.listenIndex();
	if (choice<=7&&choice>=1) 
	{
		player[turn].selectLetter(choice-1);
	}
	else
	{
		showMessage(INVALIDINDEXENTERED);
		return doSelectLetter();
	}
	/*
	newAction=listenMenu();
	switch(newAction)
	{
	case SELECTLETTER:
		return doSelectLetter();
		break;
	case CANCEL:
		player[turn].updateLetters(true);
		break;
	case DISCARD:
		//add some prompted warning message in future.
		for (i=0; i<player[turn].rackLetter.selectedCount; i++)
		{
			CToken temp;
			player[turn].rackLetter.removeToken(player[turn].rackLetter.selected[i], temp);
			bag.addLetter(temp);
		}
		player[turn].rackLetter.updateRack();//no turning back!!!
		bag.show();
		//maybe deck need refresh for displaying
		return ENDROUND;//this is considered to be end of round 
		break;
	default:
		return newAction;
	}
	*/
	return listenMenu();
}

int CControl::doSelectCard()
{	
	int choice;
	showMessage(SELECTCARD);
	choice=listener.listenIndex();
	if (choice<=7&&choice>=1) 
	{
		player[turn].selectCard(choice-1);
	}
	else
	{
		showMessage(INVALIDINDEXENTERED);//prompt user to re-enter choice
		return doSelectCard();
	}
	/*
	newAction = listenMenu();
	switch (newAction)
	{
	case SELECTCARD:
		return doSelectCard();
		break;
	case CANCEL:
		player[turn].updateCards(true);	
		break;
	case DISCARD:
		//add some prompted warning message in future.
		for (i=0; i<player[turn].rackCard.selectedCount; i++)
		{
			CToken temp;
			player[turn].rackCard.removeToken(player[turn].rackCard.selected[i], temp);
			playedDeck.addCard(temp);
		}
		player[turn].rackCard.updateRack();//no turning back!!!
		playedDeck.show();
		//maybe deck need refresh for displaying
		return ENDROUND;
		break;
	default: 
		return newAction;
	}	
	*/
	return listenMenu();
}

int CControl::doTrade()
{
	showMessage(TRADE);

	if (!player[turn].verifyCards())
	{
		showMessage(INVALIDCARDSTRADING);//warn user to reselect cards
		player[turn].updateCards(true);
		return listenMenu();//rollback
	}
	else
	{
		CToken temp;
		char ch;
		showMessage(INPUTEXCHANGELETTER);
		ch=listener.listenChar();
		ch=toupper(ch);
		if (!isalpha(ch))
		{
			player[turn].updateCards(true);
			return listenMenu();
		}
		//need some verifications here!!!!
		if (bag.removeLetter(ch, temp))
		{
			player[turn].addExchanged(ch);	
			player[turn].traded=true;
		}
		else
		{
			showMessage(CANNOTEXCHANGELETTER);//warn user to reselect cards
			player[turn].updateCards(true);				
		}			
	}
	return listenMenu();
}


void CControl::showMessage(int msgID)
{
	message.showMessage(msgID);
}

int CControl::listenMenu()
{
	int result=-1;
	while (result<1||result>9)
	{
		showMessage(WAITINGMENUCHOICE);
		result= listener.listenMenu();
	}
	menu.setSelected(result-1);
	return result;
}

void CControl::show()
{
	player[turn].show();
	playingDeck.show();
	playedDeck.show();
	board.show();
	bag.show();
	menu.show();
	//scoreboard.show(); //this is for Charles
}

void CControl::fillUpRack()
{
	CToken temp;
	for (int i=0; i<player[turn].rackCard.selectedCount; i++)
	{
		temp=player[turn].rackCard.tokens[player[turn].rackCard.selected[i]];
		if (temp.getValue()!=0)
		{
			playedDeck.addCard(temp);
		}
		if (playingDeck.removeCard(temp))
		{
			player[turn].rackCard.tokens[player[turn].rackCard.selected[i]]=temp;
		}
	}
	//player[turn].rackCard.updateRack();
	player[turn].rackCard.selectedCount=0;
	player[turn].rackCard.show();
	playingDeck.show();
	playedDeck.show();
	for (i=0; i<player[turn].rackLetter.selectedCount; i++)
	{
		temp=player[turn].rackLetter.tokens[player[turn].rackLetter.selected[i]];
		//for the initialization
		if (temp.getValue()!=0)
		{
			bag.addLetter(temp);		
		}
	}
	bag.shuffle();
	for (i=0; i<player[turn].rackLetter.selectedCount; i++)
	{
		if (bag.removeLetter(temp))
		{
			player[turn].rackLetter.tokens[player[turn].rackLetter.selected[i]]=temp;
		}
	}

	//player[turn].rackLetter.updateRack();
	player[turn].rackLetter.selectedCount=0;
	bag.show();
	player[turn].rackLetter.show();
}

void CControl::initPlayGame()
{
	turn=0;
	playingDeck.setFace(true);
	playingDeck.setCoord(DefaultPlayingDeck_x, DefaultPlayingDeck_y);
	playedDeck.setFace(false);
	playedDeck.setCoord(DefaultPlayedDeck_x, DefaultPlayedDeck_y);
	fillUpRack();
	player[turn].traded=false;
	nextTurn();
	fillUpRack();
	player[turn].traded=false;
	nextTurn();
	menu.setSelected(-1);
	show();
}


CControl::CControl()
{
}