#include "rummy.h"

bool CRummy::verify(CToken* tokens, int len)
{
	bool sameSuit=true, isSequence=true, isGroup=true;
	int theSuit, theBase, theNext;
	for (int i=0; i<len; i++)
	{
		addOne(tokens, i);
	}
	theSuit=tokens[array[0]].getSuit();
	theBase=tokens[array[0]].getNumber();
	for (i=1; i<len; i++)
	{
		if (tokens[array[i]].getSuit()!=theSuit)
		{
			sameSuit=false;
		}
		theNext=tokens[array[i]].getNumber();
		if (theNext-theBase!=0)
		{
			isGroup=false;
		}
		if (theNext-theBase!=-1)
		{
			isSequence=false;
		}
		theBase=theNext;
	}
	return sameSuit||isSequence||isGroup;
}
	

CRummy::CRummy()
{
	pos=0;
}

void CRummy::addOne(CToken* tokens, int index)
{
	int i=0;
	if (pos==0)
	{
		array[0]=index;
		pos++;
		return;
	}
	//insertion sorting	
	while (i<pos)
	{
		if (tokens[index].getNumber()>tokens[array[i]].getNumber())
		{
			break;
		}
		i++;	
	}
	
	for (int j=pos; j>i; j--)
	{
		array[j]=array[j-1];
	}
	array[i]=index;
	pos++;
}